/* copyright (c)2012..2013 Oskar Schirmer <oskar@scara.com> */
#include "chanend.h"
#include "dispatch.h"
#include "ethernet.h"
#include "print.h"
#include "reception.h"
#include "resource.h"
#include "uart.h"

void shell(resource control)
{
  int i, k;
  resource c, l, s, x, ctrl;
  unsigned char data[128];
  l = chanend_book();
  chanend_destination(l, chanend_cr_request(l, cr_uart_tx));
  c = chanend_book();
  chanend_connect(c, chanend_cr_request(c, cr_uart_rx));
  printstr(l, "Hello User.");
  println(l);
  do {
    printstr(l, "shell>");
    i = 0;
    do {
      chanend_all_sent(l);
      data[i] = chanend_read_byte(c);
      printchar(l, data[i]);
    } while ((data[i] >= ' ') && (++i < sizeof(data)));
    println(l);
    s = chanend_book();
    chanend_connect(s, chanend_cr_request(s, cr_eth_tftp));
    chanend_write_byte(s, 'R');
    for (k = 0; k < i; k++) {
      chanend_write_byte(s, data[k]);
    }
    chanend_all_sent(s);
    i = chanend_read_lsb(s, &data[0], 16);
    if (i == 16) {
      x = chanend_book();
      chanend_connect(x, chanend_cr_request(x, cr_init_dispatch));
      chanend_write_byte(x, dp_cmd_task);
      chanend_write_lsb(x, &data[0], 16);
      while (!chanend_nomore_byte(s)) {
        chanend_write_byte(x, chanend_read_byte(s));
        i += 1;
      }
      chanend_all_sent(x);
      ctrl = chanend_read_word(x);
      chanend_all_received(x);
      chanend_free(x);
    }
    chanend_all_received(s);
    chanend_free(s);
  } while (1);
  chanend_hangup_cancel(c);
  chanend_free(c);
  chanend_free(l);
}
