#ifndef _ETHERNET_H
#define _ETHERNET_H

enum {
  cr_eth_init = 0x00000020,
  cr_eth_rx,
  cr_eth_tx,
  cr_eth_arp_rx,
  cr_eth_arp_rq,
  cr_eth_ipv4,
  cr_eth_icmp,
  cr_eth_tcp,
  cr_eth_udp_rx,
  cr_eth_udp_rq,
  cr_eth_tftp
};

extern void ethernet_init(void);
extern void ethernet_rx(void);
extern void ethernet_tx(void);
extern void ethernet_arp(void);
extern void ethernet_ipv4(void);
extern void ethernet_icmp(void);
extern void ethernet_udp(void);
extern void ethernet_tftp(void);

#endif
