/* copyright (c)2012..2013 Oskar Schirmer <oskar@scara.com> */
#ifndef _RECEPTION_H
#define _RECEPTION_H

#include "resource.h"

#define chanend_cr resource_chanend(0, 0, 0)

#define cr_cmd_welcome 1
#define cr_cmd_request 2

static inline void chanend_cr_welcome(const resource chanend,
    const unsigned who)
{
  chanend_connect(chanend, chanend_cr);
  chanend_write_byte(chanend, cr_cmd_welcome);
  chanend_write_word(chanend, who);
  chanend_hangup(chanend);
}

static inline resource chanend_cr_request(const resource chanend,
    const unsigned who)
{
  resource chn;
  chanend_connect(chanend, chanend_cr);
  chanend_write_byte(chanend, cr_cmd_request);
  chanend_write_word(chanend, who);
  chanend_all_sent(chanend);
  chn = chanend_read_word(chanend);
  chanend_all_received(chanend);
  return chn;
}

#endif
