/* copyright (c)2013 Oskar Schirmer <oskar@scara.com> */
#include "print.h"
#include "reception.h"
#include "resource.h"
#include "uart.h"

void testportio(resource control)
{
  resource r, t;
  int i;
  resource log;
  log = chanend_book();
  chanend_destination(log, chanend_cr_request(log, cr_uart_tx));
  printstr(log, "Port I/O");
  println(log);
  r = port_book(1, 5); /* P1G0 XnD22 */
  t = port_book(1, 7); /* P1H0 XnD23 */
  port_on(r);
  port_on(t);
  port_write(t, 1);
  for (i = 0; i < (1 << 16); i++) {
    port_config_cond(r, port_cond_eq, 0);
    port_read(r);
    port_write(t, 0);
    port_config_cond(r, port_cond_neq, 0);
    port_read(r);
    port_write(t, 1);
  }
  port_free(r);
  port_free(t);
  printstr(log, "Port I/O done");
  println(log);
  chanend_free(log);
}
